import { BasicColumn, FormSchema } from '/@/components/Table';
import { getTown, getHylb, dict } from '/@/api/common/api';
import { convertTreeData } from '/@/utils/modifFiled';
import { useUserStore } from '/@/store/modules/user';
import { ref } from 'vue';

const userStore: any = useUserStore();

export const useSuspectsData = () => {
  const suspects = ref([]);
  // 获取行业分类
  const getIsSuspect = async () => {
    suspects.value = await dict({ key: 'dk_hyfl' });
  };
  getIsSuspect();
  return { data: suspects };
};

export const useCategoryData = () => {
  let allCategory = [];
  const treeData = ref([]);
  // 获取行业类别
  const getData = async () => {
    allCategory = await getHylb({});
    allCategory = convertTreeData(allCategory); // 只显示前2级
    // allCategory.forEach((item: any) => {
    //   item.disabled = true; 
    // });
    // treeData.value = allCategory;
  };
  getData();
  // 改变行业分类
  function changeIsSuspect(v) {
    if (v == 1) {
      // 只显示42号类
      treeData.value = allCategory.filter((item) => item['is42']);
    } else {
      treeData.value = allCategory;
    }
  }
  return { data: treeData, changeIsSuspect };
};

export const columns: BasicColumn[] = [
  {
    title: '市',
    dataIndex: 'cityName',
    resizable: true,
  },
  {
    title: '县',
    dataIndex: 'countryName',
    resizable: true,
  },
  {
    title: '地块名称',
    dataIndex: 'wrdkmc',
    resizable: true,
  },
  {
    title: '地块编码',
    dataIndex: 'wrdkbm',
    resizable: true,
  },
  {
    title: '行业类别',
    dataIndex: 'hylb',
    resizable: true,
  },
  {
    title: '政策依据',
    dataIndex: 'faliYiju',
    resizable: true,
  },
  {
    title: '地块类型',
    dataIndex: 'dklx',
    resizable: true,
  },
  {
    title: '退出状态',
    dataIndex: 'tcdw',
    resizable: true,
    customRender: ({ record }: any) => {
      if (record.tcwr == '0') {
        return '未退出'
      } else if (record.tcwr == '1')
        return '已退出'
      else if (record.tcwr == '2') return '申请退出'
    },
  },
  {
    title: '更新时间',
    dataIndex: 'tsamp',
    resizable: true,
  },
  {
    title: '登录帐号',
    dataIndex: 'userId',
    resizable: true,
  },
];

// T1：填报中 DSL：待受理 T2：待评审 SH：评审通过 SHBTG：评审不通过 SHHDWS：评审后待完善 BPS：不评审 DKDTC：地块待退出 DKYTC：地块已退出
export const searchFormSchema: FormSchema[] = [
  {
    label: '行政区(市)',
    field: 'cityCode',
    component: 'ApiSelect',
    ifShow: () => {
      return userStore?.userInfo?.userIdentity == '1' ? true : false
    },
    componentProps: ({ formModel, formActionType }) => {
      return {
        api: getTown,
        params: 440000, // 行政区划编码
        labelField: 'name',
        valueField: 'id',
        onChange: (val: any) => {
          const { updateSchema } = formActionType;
          formModel.countryCode = undefined;
          if (val) {
            updateSchema({
              field: 'countryCode',
              componentProps: {
                api: getTown,
                params: val,
                labelField: 'name',
                valueField: 'id',
              },
            });
          } else {
            updateSchema({
              field: 'countryCode',
              componentProps: {
                api: undefined,
                labelField: 'name',
                valueField: 'id',
              },
            });
          }
        },
      };
    },
  },
  {
    label: '区县',
    field: 'countryCode',
    component: 'ApiSelect',
    ifShow: () => {
      return (userStore?.userInfo?.userIdentity == '2' || userStore?.userInfo?.userIdentity == '1') ? true : false
    },
    componentProps: ({ formModel, formActionType }) => {
      if (userStore?.userInfo?.userIdentity == '2') {
        const { updateSchema } = formActionType;
        updateSchema({
          label: '区县',
          field: 'countryCode',
          ifShow: true,
          componentProps: {
            api: getTown,
            params: userStore?.userInfo?.codeRegion,
            labelField: 'name',
            valueField: 'id',
          },
        });
      }
      return {
        labelField: 'name',
        valueField: 'id',
      }
    },
  },
  {
    label: '行业分类',
    field: 'isSuspect',
    component: 'ApiSelect',
    slot: 'suspect',
  },
  {
    label: '行业类别',
    field: 'hylb',
    component: 'TreeSelect',
    slot: 'category',
  },
  {
    label: '地块类型',
    field: 'dklx',
    component: 'JSearchSelect',
    componentProps: {
      dict: 'dk_dklx',
    },
  },
  // {
  //   label: '地块名称',
  //   field: 'wrdkmc',
  //   component: 'Input',
  // },
  {
    label: '地块名称或者编码',
    field: 'wrdkbm',
    component: 'Input',
  },
  {
    label: '登录帐号',
    field: 'userId',
    component: 'Input',
  },
];

// 方案列表
export const Fxcolumns: BasicColumn[] = [
  {
    title: '风险管控效果评估标题',
    dataIndex: 'bt',
    resizable: true,
  },
  {
    title: '编制单位',
    dataIndex: 'bzdw',
    resizable: true,

  },
  {
    title: '填报状态',
    dataIndex: 'tbzt',
    resizable: true,
  },
  {
    title: '更新日期',
    dataIndex: 'tsamp',
    resizable: true,
  },
  {
    title: '退回状态',
    dataIndex: 'wrdkmc',
    resizable: true,
  },
];

// 退回
export const BackFormSchema: FormSchema[] = [
  {
    label: '污染地块id',
    field: 'wrdkid',
    component: 'ApiSelect',
    show: false,
  },
  {
    label: '阶段编码',
    field: 'scjdbm',
    component: 'ApiSelect',
    show: false,
  },
  {
    label: '填报阶段编码',
    field: 'tbjdbm',
    component: 'ApiSelect',
    show: false,
  },

  {
    label: '退回意见',
    field: 'clyj',
    component: 'Input',
    required: true
  },
  {
    label: '文件',
    field: 'clyjfj',
    component: 'JUpload',
    required: true,
    componentProps: {
      showUploadList: false,
      fileName: '退回文件',
    }
  },
]